Skip to content
Get started

Get user portfolio

GET/api/v1/users/{address}/wallet/balances

Get user portfolio

Path ParametersExpand Collapse
address: string

The user account address

Query ParametersExpand Collapse
with_text: optional boolean

Include text variation fields

with_value: optional boolean

Calculate and include USD values for amounts, where applicable

ReturnsExpand Collapse
data: UserWalletPortfolio { balances, extra, total_value }
balances: array of WalletBalance { asset, values }

Array of each wallet balance

asset: AssetSpec { id, group, group_key }

Provides a unique identifier for an asset for use throughout the Neptune API. IDs are unique across asset domains (contract tokens, native denoms, etc)

id: string
group: "native" or "token"
One of the following:
"native"
"token"
group_key: string
values: WalletAsset

Derived values and amounts.

One of the following:
WalletAssetKnown = object { amount, amount_scaled, asset_info, 2 more }
amount: string

Wallet balance in native denom.

amount_scaled: string

Amount scaled to the asset's standard unit / decimal places.

asset_info: AssetInfo { asset, classification, metadata }

Asset identifiers with associated metadata

asset: AssetSpec { id, group, group_key }

Provides a unique identifier for an asset for use throughout the Neptune API. IDs are unique across asset domains (contract tokens, native denoms, etc)

id: string
group: "native" or "token"
One of the following:
"native"
"token"
group_key: string
classification: AssetClassification

The asset's classification metadata. Assets are classfied to provide context on their usage throughout the Neptune API (e.g. regular assets, neptune receipt tokens, LSTs, etc.)

Each asset belongs to only a single classification type. This object contains metadata pertaining to the given classification.

While some fields may be common among the distinct classifcations, each classification is distinct and subject to independent change.

One of the following:
Regular = object { kind, neptune_receipt_asset }
kind: "regular"
neptune_receipt_asset: AssetSpec { id, group, group_key }

Provides a unique identifier for an asset for use throughout the Neptune API. IDs are unique across asset domains (contract tokens, native denoms, etc)

id: string
group: "native" or "token"
One of the following:
"native"
"token"
group_key: string
NeptuneReceiptToken = object { kind, origin_asset }
kind: "neptune_receipt_token"
origin_asset: AssetSpec { id, group, group_key }

Provides a unique identifier for an asset for use throughout the Neptune API. IDs are unique across asset domains (contract tokens, native denoms, etc)

id: string
group: "native" or "token"
One of the following:
"native"
"token"
group_key: string
LiquidStakingToken = object { kind, origin_asset }
kind: "liquid_staking_token"
origin_asset: AssetSpec { id, group, group_key }

Provides a unique identifier for an asset for use throughout the Neptune API. IDs are unique across asset domains (contract tokens, native denoms, etc)

id: string
group: "native" or "token"
One of the following:
"native"
"token"
group_key: string
metadata: AssetMetadata { decimals_denom, decimals_display, name, 2 more }

Additional metadata for assets

decimals_denom: number

Denom exponent, or num. of decimal places that shift between denom/standard amounts (e.g. 18 for INJ)

formatuint32
minimum0
decimals_display: number

Number of decimals used when displaying amounts of this asset (this is subjective and used for generating text representations)

formatuint32
minimum0
name: string

Full name of the asset

symbol: string

Symbol of the asset, e.g.: NEPT INJ

symbol_denom: string

Denom symbol for the asset (e.g. inj for INJ, sat for BTC)

extra: object { text, value }
text: object { amount }

Human-readable field variants. Will not be null when query param with_text is true.

amount: string
value: object { amount, extra, price }

USD values for the corresponding amounts above. Will not be null when query param with_value is true.

Note

This variant group contains an additional price field (set to the number used in value calculation).

The embedded text group will contain the text variant if with_text was specified as well.

amount: string
extra: object { text }
text: object { amount, price }

Human-readable variants of USD values. Will not be null when query params with_text and with_value are true.

amount: string
price: string

Text representation of price

price: string

Price used in value calculations

kind: "known"
WalletAssetUnknown = object { amount, kind }
amount: string

Wallet balance in native denom.

kind: "unknown"
extra: object { text }
text: object { total_value }

Human-readable field variants. Will not be null when query param with_text is true.

total_value: string
total_value: string

Sum value in USD. Guaranteed null if value calculation is disabled / guaranteed non-null if calculation is enabled.

NOTE: this only accounts for assets which are internally known & tracked. See the /assets endpoint for a list of supported assets.

error: unknown

Error data. Guaranteed null for successful response.

status: number

HTTP status. Successful responses are guaranteed to be < 400. Conversely, error responses are guaranteed to be >= 400.

formatuint16
minimum0
maximum65535
status_text: string

HTTP status text

Get user portfolio

curl https://api-v2.nept.finance/api/v1/users/$ADDRESS/wallet/balances
{
  "data": {
    "balances": [
      {
        "asset": {
          "id": "native;inj",
          "group": "native",
          "group_key": "inj"
        },
        "values": {
          "kind": "known",
          "asset_info": {
            "asset": {
              "id": "native;inj",
              "group": "native",
              "group_key": "inj"
            },
            "metadata": {
              "name": "Injective",
              "symbol": "INJ",
              "symbol_denom": "inj",
              "decimals_denom": 18,
              "decimals_display": 4
            },
            "classification": {
              "kind": "regular",
              "neptune_receipt_asset": {
                "id": "token;inj1rmzufd7h09sqfrre5dtvu5d09ta7c0t4jzkr2f",
                "group": "token",
                "group_key": "inj1rmzufd7h09sqfrre5dtvu5d09ta7c0t4jzkr2f"
              }
            }
          },
          "amount": "375425343522854919091",
          "amount_scaled": "375.425343522854919091",
          "extra": {
            "text": {
              "amount": "375.4253 INJ"
            },
            "value": {
              "amount": "1125.656578751752046656",
              "price": "2.99835",
              "extra": {
                "text": {
                  "price": "$2.99",
                  "amount": "$1,125.65"
                }
              }
            }
          }
        }
      }
    ],
    "total_value": "626.552120573717882332",
    "extra": {
      "text": {
        "total_value": "$626.55"
      }
    }
  },
  "error": null,
  "status": 200,
  "status_text": "200 OK"
}
{
  "data": null,
  "error": {
    "kind": "internal",
    "scope": "server",
    "message": "An unexpected error occurred"
  },
  "status": 500,
  "status_text": "500 Internal Server Error"
}
Returns Examples
{
  "data": {
    "balances": [
      {
        "asset": {
          "id": "native;inj",
          "group": "native",
          "group_key": "inj"
        },
        "values": {
          "kind": "known",
          "asset_info": {
            "asset": {
              "id": "native;inj",
              "group": "native",
              "group_key": "inj"
            },
            "metadata": {
              "name": "Injective",
              "symbol": "INJ",
              "symbol_denom": "inj",
              "decimals_denom": 18,
              "decimals_display": 4
            },
            "classification": {
              "kind": "regular",
              "neptune_receipt_asset": {
                "id": "token;inj1rmzufd7h09sqfrre5dtvu5d09ta7c0t4jzkr2f",
                "group": "token",
                "group_key": "inj1rmzufd7h09sqfrre5dtvu5d09ta7c0t4jzkr2f"
              }
            }
          },
          "amount": "375425343522854919091",
          "amount_scaled": "375.425343522854919091",
          "extra": {
            "text": {
              "amount": "375.4253 INJ"
            },
            "value": {
              "amount": "1125.656578751752046656",
              "price": "2.99835",
              "extra": {
                "text": {
                  "price": "$2.99",
                  "amount": "$1,125.65"
                }
              }
            }
          }
        }
      }
    ],
    "total_value": "626.552120573717882332",
    "extra": {
      "text": {
        "total_value": "$626.55"
      }
    }
  },
  "error": null,
  "status": 200,
  "status_text": "200 OK"
}
{
  "data": null,
  "error": {
    "kind": "internal",
    "scope": "server",
    "message": "An unexpected error occurred"
  },
  "status": 500,
  "status_text": "500 Internal Server Error"
}